unit cgi;

{ CGI (c) 1999 by Paul TOTH <tothpaul@multimania.com>
  http://www.multimania.com/tothpaul
}

{ CGI Interface for easy Delphi CGI } 

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

interface

uses
 windows,classes,sysutils,graphics;

var
 parmstring:string;
 parms:TStringList;

function getvar(varname:string):string;
function getcookie(name:string):string;

procedure WriteStream(stream:TMemoryStream);
procedure WriteFile(Filename:string);

function DateGMT(Date:TDateTime):string;

implementation

function getvar(varname:string):string;
 var
  buffer:array[0..1024] of char;
  size:integer;
 begin
  size:=GetEnvironmentVariable(PChar(varname),buffer,sizeof(buffer));
  if size=0 then getvar:='' else getvar:=String(buffer);
 end;

function getcookie(name:string):string;
 var
  cookie:string;
  p:byte;
 begin
  cookie:=GetVar('HTTP_COOKIE');
  name:=name+'='; p:=pos(name,cookie);
  if p=0 then
   Result:=''
  else begin
   Delete(cookie,1,p+length(name)-1);
   p:=pos(';',cookie);
   if p=0 then p:=pos(' ',cookie);
   if p=0 then p:=length(cookie)+1;
   result:=copy(cookie,1,p-1);
  end;
 end;

procedure ProcessMessages;
 var
  Msg: TMsg;
 begin
  while PeekMessage(Msg, 0, 0, 0, PM_REMOVE) do begin
   TranslateMessage(Msg);
   DispatchMessage(Msg);
  end;
end;


procedure initcgi;
 const
  hexa:array[0..$F] of char='0123456789ABCDEF';
 var
  x:integer;
  n,v:string;
  size,i:word;
  procedure addchar(var s:string);
   begin
    case parmstring[x] of
     '%': begin
           inc(x);
           s:=s+chr(16*(pos(parmstring[x],hexa)-1)+pos(parmstring[x+1],hexa)-1);
           inc(x);
          end;
     '+': s:=s+' ';
     else s:=s+parmstring[x];
    end;
    inc(x);
   end;
 begin
 // get parm string
  if getvar('REQUEST_METHOD')='POST' then begin
   parmstring:=getvar('CONTENT_LENGTH');
   if parmstring<>'' then begin
    size:=strtoint(parmstring);
    setlength(parmstring,size);
    for i:=1 to size do read(parmstring[i]);
   end;
  end else
   parmstring:=getvar('QUERY_STRING');
 // create parms
  parms:=TStringList.create;
  x:=1;
  while x<=length(parmstring) do begin
   // get name
   n:=''; while (x<=length(parmstring))and(parmstring[x]<>'=') do addchar(n); inc(x);
   // get value
   v:=''; while (x<=length(parmstring))and(parmstring[x]<>'&') do addchar(v); inc(x);
   // add it
   parms.add(n+'='+v);
  end;
 // convert ParmString
  n:=''; x:=1;
  while x<=length(parmstring) do addchar(n);
  parmstring:=n;
 // ProcessMessages;
 end;


procedure WriteStream(Stream:TMemoryStream);
 var
  buffer:array[0..1024] of char;
  l:integer;
  f:file;
  OutputStream:THandleStream;
 begin
  Flush(Output);
// code from DCounter for Delphi 3 by Dave Wedwick (dwedwick@bigfoot.com)
  OutputStream:=THandleStream.Create(GetStdHandle(STD_OUTPUT_HANDLE));
  Stream.SaveToStream(OutputStream);
  OutputStream.Free;
 end;

procedure WriteFile(FileName:string);
 var
  s:TMemoryStream;
 begin
  s:=TMemoryStream.Create;
  s.LoadFromFile(FileName);
  WriteStream(s);
  s.Free;
 end;

const
 Days  :pchar='SunMonTueWedThuFriSat';
 Months:pchar='JanFebMarAprMayJunJulAugSepOctNovDec';


Function DateGMT(Date:TDateTime):string;
 var
  Y,Mt,D,DOW,H,Mn,S,ms:word;
  TZInfo:TTimeZoneInformation;
 begin
  GetTimeZoneInformation(TZInfo);
  Date:=Date+60*TZInfo.Bias;

  DecodeDate(Date,Y,Mt,D); Dow:=DayOfWeek(Date);
  DecodeTime(Date,H,Mn,S,ms);
         //1...:....0....:....0....:....0
  Result:='ddd, 00 mmm 0000 00:00:00 GMT'; // Thu, 01 Dec 1994 16:00:00 GMT
  Move(Days[3*(Dow-1)],Result[1],3);
  Inc(Result[06],D  div 10);
  Inc(Result[07],D  mod 10);
  Move(Months[3*(Mt-1)],Result[9],3);
  Inc(Result[13],(Y div 1000));
  Inc(Result[14],(Y div 100) mod 10);
  Inc(Result[15],(Y div 10) mod 10);
  Inc(Result[16],(Y mod 10));
  Inc(Result[18],H  div 10);
  Inc(Result[19],H  mod 10);
  Inc(Result[21],Mn div 10);
  Inc(Result[22],Mn mod 10);
  Inc(Result[24],S  div 10);
  Inc(Result[25],S  mod 10);
 end;

// exit proc

var
 oldexit:pointer;
procedure donecgi; far;
 begin
  exitproc:=oldexit;
  parms.free;
 end;

begin
 initcgi;
 oldexit:=exitproc;
 exitproc:=@donecgi;
end.
